// Definicija klase za nizove figura (Niz).

#ifndef _niz3_h_
#define _niz3_h_

#include "zbirka.h"

class Niz: public Zbirka {
  friend class N_iter;                         // Iterator za nizove.
  Figura** niz;                                // Elementi niza.
  int kap, duz;                                // Kapacitet i duina.
  void kopiraj(const Zbirka& z);               // Kopiranje u niz.
  void premesti(Zbirka& z) {                   // Premetanje u niz.
    Niz& n = dynamic_cast<Niz&>(z);
    niz = n.niz; kap = n.kap; duz = n.duz;
    n.niz = nullptr;
  }
  void brisi() { ~*this; delete [] niz; }      // Oslobaanje memorije.
public:
  explicit Niz(int k=10)                       // Stvaranje praznog niza.
    { niz = new Figura* [kap = k]; duz = 0; }
  int vel() const { return duz; }              // Broj elemenata zbirke.
  Niz& operator+=(Figura* fig);                // Dodavanje figure.
  Figura*& operator[](int ind) {               // Dohvatanje figure.
    if (ind<0 || ind >= duz) greska(G_IND);
    return niz[ind];
  }
  using Zbirka::operator[];
  Niz& operator~();                            // Pranjenje niza.
  Niz* kopija() const                          // Stvaranje kopije niza.
    { return new Niz(*this); }
  Iter* iter();                                // Stvaranje iteratora.
  const Iter* iter() const;
};

#endif
