// Definicija klase redova (Red).

class Red {
  struct Elem {                             // Elementi reda:
    int   pod;                              // - sadrzaj elementa,
    Elem* sled;                             // - sledeci element;
    Elem(int p, Elem* s=nullptr)            // - konstruktor.
      { pod = p; sled = s; }
  };
  Elem *prvi, *posl;                        // Pocetak i kraj reda.
  int   duz;                                // Duzina reda.
  void kopiraj(const Red& r);               // Kopiranje u red.
  void premesti(Red& r) {                   // Premestanje u red.
    prvi = r.prvi; posl = r.posl; duz = r.duz;
    r.prvi = r.posl = nullptr;
  }
  void brisi();                             // Oslobadjanje memorije.
public:
  Red() { prvi = posl = nullptr; duz = 0; } // Konstruktor praznog reda.
  Red(int a)                                // Konverzija int u Red.
    { prvi = posl = new Elem(a); duz = 1; }
  Red(const Red& r) { kopiraj(r); }         // Kopirajuci konstruktor.
  Red(Red&& r) { premesti(r); }             // Premestajuci konstruktor.
  ~Red() { brisi(); }                       // Destruktor.
  Red& operator=(const Red& r) {            // Kopirajuca dodela vrednosti.
    if (this != &r) { brisi(); kopiraj(r); }
    return *this;
  }
  Red& operator=(Red&& r) {              // Premestajuca dodela vrednosti.
    if (this != &r) { brisi(); premesti(r); }
    return *this;
  }
  int operator+() const { return duz; }  // Duzina reda.
  Red& operator+=(const Red& r);         // Dodavanje reda.
  Red operator+  (const Red& r) const    // Spoj dva reda.
    { return Red(*this) += r; }
  int operator--();                      // Brisanje prvog elementa.
  int operator- () const                 // Prvi element.
    { return duz ? prvi->pod : 0; }
  Red operator-  (int k) const;          // Red bez elemenata jednakih k.
  Red& operator-=(int k)          // Brisanje svih elemenata jednakih k.
    { return *this = *this - k; }
  Red& operator~()                // Brisanje svih elemenata.
    { brisi(); return *this; }
};

