// Inicijalizacija i dodela vrednosti.

#include <cstring>
#include <iostream>
using namespace std;

class Tekst {
  char* txt;                       // Pokazivac na sam tekst.
  
  void kopiraj(const Tekst& t) {   // Kopiranje u Tekst.
    txt = new char [strlen(t.txt)+1];
    strcpy(txt, t.txt);
  }
  
  void premesti(Tekst& t)          // Premestanje u Tekst.
    { txt = t.txt; t.txt = nullptr; }
  
  void brisi() { delete [] txt; }  // Oslobadjanje memorije.

public:
  Tekst(const char* niz) {        // Konverzija iz char* u Tkest.
    txt = new char [strlen(niz)+1];
    strcpy(txt, niz);
  }

  Tekst(const Tekst& t)           // Kopirajuca inicijalizacija Tkest-om.
    { kopiraj(t); }

  Tekst(Tekst&& t)                // Premestajuca inicijalizacija Tkest-om.
    { premesti(t); }
  
  ~Tekst() { brisi(); }           // Unistavanje objekta.

  Tekst& operator=(const Tekst& t) {    // Kopirajuca dodela vrednosti.
    if (this != &t) { brisi(); kopiraj(t); }
    return *this;
  }

  Tekst& operator=(Tekst&& t) {         // Premestajuca dodela vrednosti.
    if (this != &t) { brisi(); premesti(t); }
    return *this;
  }
};

Tekst f(const char* niz)          // Vraca privremeni objekat.
  { return Tekst(niz); }

int main() {                      // Stvaranje i inicijalizacija:
  Tekst a("Dobar dan.");          // - poziva se Teskt(char*),
  Tekst b = Tekst ("Zdravo.");    // - poziva se Tekst(char*),
  Tekst c(a), d = b;              // - poziva se Teskt(const Tekst&),
  Tekst e = Tekst(f("Pozdrav.")); // - poziva se Tekst(&&).
                                  // Dodela vrednosti:
  a = b;                          // - poziva se operator=(const Teskt&),
  a = f("Pozdrav.");              // - poziva se operator=(Teskt&&).
}

